$nodebug
	subroutine DPVT(x,y,nx,ny,Nmax,eps,ier)
c
c
c	        This is a routine designed to solve a set of n linear eqations
c	        by the gauss elimination technique.
c
c	        parameters :
c
c	x...............nmax*nx real*8 matrix containing the coefficients of 
c	                the equations
c	y...............nmax*ny real*8 matrix containing the right hand sides.
c	                Returns the solution
c	nx..............integer*2 number of unkowns and number of equations
c	ny..............integer*2 number of R.H.S
c	Nmax............Actual number of row of X and Y
c	eps.............Threshold for the pivot
c	ier.............integer*2 return code
c			 0: resolution completed succesfully
c			-i: pivot not found in step i of elimination
c
c     modif du 30/10/96 pour le calcul du dterminant
c     on compte le nombre de permutations ==> is

      implicit real*8 (a-h,o-z)
      common/DPVTs/is
	dimension x(nmax,nx),y(nmax,ny)
c
c
c		compute the threshold for pivot
c
	is = 1
	ier=0
	tol=0.
	do 10 i=1,nx
	do 10 j=1,nx
	tol=tol+dabs(x(i,j))
10	continue
	tol=tol/nx/nx*eps
c
c
c
	do 20 j=1,nx-1
c
c		find the bigest element of row j as pivot
c
	bigx=0.
	imax=j
	do 30 i=j,nx
	z=dabs(x(i,j))
	if (z.gt.bigx) then
	imax=i
	bigx=z
	endif
30	continue
c
c		check the pivot strength
c
	if (dabs(bigx).lt.tol) then
	if(ier.eq.0)ier=-j
	endif
c
c	        swap line imax and j on matrix and R.H.S
c             only when necessary and change sign of signature 
c             (30/10/96)

      if(imax.ne.j) then
      do 40 k=j,nx
	z=x(imax,k)
	x(imax,k)=x(j,k)
	x(j,k)=z
40	continue
      is = -is
      endif
c
c     
c
      do 41 k=1,ny
	z=y(imax,k)
	y(imax,k)=y(j,k)
	y(j,k)=z
41	continue
c
c		elimination step # j : only if z.ne.0
c
	do 50 i=j+1,nx

	z=x(i,j)/x(j,j)
      if(z.ne.0.d0) then
	do 60 k=j+1,nx
	x(i,k)=x(i,k)-z*x(j,k)
60	continue
	do 51 k=1,ny
	y(i,k)=y(i,k)-z*y(j,k)
51	continue
      endif

50	continue
c
c		end of elimination loop (triangularisation)
c
20	continue

c		back resolution

c		check the last pivot strength !

	if (dabs(x(nx,nx)).lt.tol) then
	if(ier.eq.0)ier=-nx
	endif

c     if only det is sought for, return
	
      if(ny.eq.0)return

	do 69 k=1,ny
	y(nx,k)=y(nx,k)/x(nx,nx)
69	continue
	do 70 i=nx-1,1,-1
	do 71 k=1,ny	
	do 80 j=i+1,nx
	y(i,k)=y(i,k)-x(i,j)*y(j,k)
80	continue
	y(i,k)=y(i,k)/x(i,i)
71	continue
70	continue
c
c		return to calling routine
c
	return
	end
