c$debug
c
c
c
c                
c       Calcul 3D sur l'quation de Laplace
c
c             LE 10 mars 1994
c
c
c

$include:'u:\alphamet\3D\L3D02.inc'
      
      real*4 time
      character*80 filein, Fileout
	logical diagdom, pivot
c	character str*82
c
      common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax)  
      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              XP(3,4,Nmax), XM(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	DIMENSION W(Nmax)
	pivot=.false.

      Pi = 4.d0 * datan(1.d0)
C
C       READ NAMES AND OPEN FILES FOR INPUT AND OUTPUT
C
	write(*,'('' L3D02'')')

      CALL GETFNAMES(FILEIN, FILEOUT)
	OPEN(5,FILE=FILEIN,STATUS='OLD')
	OPEN(6,FILE=FILEOUT,STATUS='UNKNOWN')
C
C       READ DATA
C
      CALL INPUT3D
      close(5)
C
C       COMPUTE THE GEOMETRICAL QUANTITIES OF INTEREST
C
      CALL GEOM
c
c       Calcul des coefficients d'Influence
c
	call startsw
c
c       Boucle sur les points de controles
c
	do 10 i = 1,nfa

	if( mod(i,10).eq.0) then
	write(*,'('' Calculation line #'',i4,''/'',i4,\)')i,nfa
	call rclsw(time)
	write(*,'('', time :'',f8.3)')time
	endif
c
      Dvs(i) = 0.d0
c
c       Boucle sur les elements
c
      do 11 j = 1,nfa
c 	write(*,*) 'i, j=',i,j
      SYS1(i,j) = 0.d0
c
      G = 0.d0
      if(I. eq .j) then
      H = -.5d0 
      else
      H = 0.d0
      endif
c
c
c       Generation des 8 points symetriques
c
c
	
      do 20 ix = Nsx,1,2
      Kx = 1
      If(ix.eq.-1) Kx = Ksx
      
      do 20 iy = Nsy,1,2
      Ky = 1
      If(iy.eq.-1) Ky = Ksy
      
      do 20 iz = Nsz,1,2
      Kz = 1
      If(iz.eq.-1) Kz = Ksz
c
c
c
c      write(*,'('' i,j,ix,iy,iz,Kx,Ky,Kz'',2i5,2x,3i3,2x,3i3)')
c     & i,j,ix,iy,iz,Kx,Ky,Kz  

      call lnflux( ix*XM(1,i), iy*XM(2,i), iz*XM(3,i) , j, G1, H1)


      G = G + Kx*Ky*Kz * G1
      H = H + Kx*Ky*Kz * H1

20    continue

      if(Kode(j). gt.0) then
      
      SYS1(i,j) = SYS1(i,j) -       H
      Dvs(i)    = Dvs(i)    -       G * Vs(j)
      
      else
      
      SYS1(i,j) = SYS1(i,j) +       G
      Dvs(i)    = Dvs(i)    +       H * Vs(j)
      
      endif

11      continue
10      continue        
C
C	RESOLUTION DU SYSTEME
C
C	Check for diagonal dominance
C
	write(*,*)
	diagdom=.true.
	DO j=1,NFA
	sumextrad=0
	DO i=1,NFA
	if(i.ne.j)sumextrad=sumextrad+dabs(SYS1(i,j))
	enddo
	diagdom = diagdom.and.dabs(SYS1(j,j)).gt.sumextrad
      enddo
	
	if(Diagdom) then
	Write(*,'('' The matrix is diagonally dominant'')')
	else
	Write(*,'('' The matrix is NOT diagonally dominant'')')
	endif      
C
	call startsw

	if(pivot)then
c
	call DPVT(SYS1,DVS,nfa,1,NMAX,1.D-6,ier1)
	if(ier1.ne.0)then
	write(*,'('' Ier non zero in PVT :'',i4)')ier1
	endif
c
	else
	
     	do i=1,NFA
	W(i)=0.d0
	enddo

	call DGSEIDEL(SYS1,DVS,W,nfa,1,NMAX,1.d-8,ier1)
	if(ier1.ne.0)then
	write(*,'('' Too many iterations in GSEIDEL :'',i4,''/'',i4)')
	& -ier1,Nfa
	endif

	endif
c
	call affsw
c
c     Reorder the unknowns 
c
C
C       REARRANGE THE FI AND DFI ARRAYS TO STORE ALL THE VALUES OF THE
C       POTENTIAL IN FI AND ALL THE VALUES OF THE DERIVATIVE IN DFI
C
	DO 25 I=1,Nfa
	IF(KODE(I).GT.0) Then
      CH=VS(I)
	VS(I)=DVS(I)
	DVS(I)=CH
      endif
25    CONTINUE
C
C	PRINT RESULTS AT BOUNDARY NODES AND INTERNAL POINTS
C
	CALL INTEMPC
	CALL OUTPMPC
c	write(6,'(//'' RESULTS''/)')c
c	do 27 i=1,nfa
c27      write(6,'(i5,5x,f12.6,f10.6)')i,Vs(i),DVS(i)
c
c     Calcul des courants
c
      call CURRENT
	end 
$page
	subroutine lnflux(xpi,ypi,zpi,j,phi,dphi)
c
c
c       Calculation of influence matrix coefficients
c       version of influx with loop on the side number
c       and no call to external routine like side12
c
c

$include:'L3D02.inc'

      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              Q(3,4,Nmax), P(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	dimension xQ(4),yQ(4),zQ(4)
      data init/0/
      
      if(init.eq.0)then
      Pi = 4.d0*datan(1.d0)
      unsm4pi = -1.d0/4.d0/Pi
      init = 1
      endif

c
	nc = ncote(j)
c
c       Calculation of the local basis
c
c       N = Q1Q2 x Q2Q3
c
	do 1 ic = 1,nc

	xQ(ic) = Q(1,ic,j)- P(1,j)
	yQ(ic) = Q(2,ic,j)- P(2,j) 
	zQ(ic) = Q(3,ic,j)- P(3,j)

1       continue

	x12 = xQ(2) - xQ(1)
	y12 = yQ(2) - yQ(1)
	z12 = zQ(2) - zQ(1)

	x23 = xQ(3) - xQ(2)
	y23 = yQ(3) - yQ(2)
	z23 = zQ(3) - zQ(2)

c       xP = P(1,i) - P(1,j)
c       yP = P(2,i) - P(2,j)
c       zP = P(3,i) - P(3,j)
c
	xP = xPi - P(1,j)
	yP = yPi - P(2,j)
	zP = zPi - P(3,j)

c       r02 = xP*xP + yP*yP + zP*zP

	xN = y12 * z23 - z12 * y23
	yN = z12 * x23 - x12 * z23
	zN = x12 * y23 - y12 * x23
	
	aLN = sqrt ( xN*xN + yN*yN + zN*zN )

	xN = xN / aLN
	yN = yN / aLN
	zN = zN / aLN
c       write(*,'(''   XN :'',3f10.5)') xN,yN,zN
c
c
c       Ox = Q1Q2
c
c
	aLX = sqrt ( x12*x12 + y12 * y12 + z12 * z12 )
	xX = x12 / aLX
	yX = y12 / aLX
	zX = z12 / aLX
c       write(*,'(''   Ox :'',3f10.5)') xX,yX,zX
c
c
c       Oy = N x Ox
c
c               
	xY = yN * zX - zN * yX
	yY = zN * xX - xN * zX
	zY = xN * yX - yN * xX
c       write(*,'(''   Oy :'',3f10.5)') xY,yY,zY
c
c
c       Calculation of the coordinates of the observer point
c       in the local basis
c
c
c       x = Ox.OP    y = Oy.OP   z = N.OP
c
	x = xX * xP  +  yX * yP  +  zX * zP
	y = xY * xP  +  yY * yP  +  zY * zP     
	z = xN * xP  +  yN * yP  +  zN * zP
c       write(*,'('' LB-P :'',3f10.5)') x,y,z
c
	sgnz   = dsign ( 1.d0, z )
	az     = dabs(z)
	zsq    = z*z
c
c
c       Calculation of the influence of the element
c       by summing up the contributions of each side
c
c
	do 2 ic = 1,nc
c
c       Calculation of the coordinates of the edges in the
c       local basis
c
	if(ic.eq.1) then

	x1 = xX * xQ(1)  +  yX * yQ(1)  +  zX * zQ(1)
	y1 = xY * xQ(1)  +  yY * yQ(1)  +  zY * zQ(1)   
c
	savex1 = x1     
	savey1 = y1
c
	x2 = xX * xQ(2)  +  yX * yQ(2)  +  zX * zQ(2)
	y2 = xY * xQ(2)  +  yY * yQ(2)  +  zY * zQ(2)   
c       
	Phi  = 0.d0
	dPhi = 0.d0
	iphi = 0
c
c       Last side
c
	elseif(ic.eq.nc)then

	x1 = x2
	y1 = y2
	
	x2 = savex1
	y2 = savey1
c
c       Intermediate sides
c
	else

	x1 = x2
	y1 = y2
c
	x2 = xX * xQ(ic+1)  +  yX * yQ(ic+1)  +  zX * zQ(ic+1)
	y2 = xY * xQ(ic+1)  +  yY * yQ(ic+1)  +  zY * zQ(ic+1)  
c       
	endif
c
c
c       Calculation of the influence of each side
c
c
c        Analytical formulas
c
c
c       1 - Quantities which do not involve the observer point
c
	d12    = dsqrt( (x2-x1)**2 + (y2-y1)**2 )
	c12    = (x2 - x1) / d12
	s12    = (y2 - y1) / d12
c
c       2 - Quantities  involving also the observer point
c
c       sines and cosine of the direction P1P2
c
	s121   = (x1 - x)*c12 + (y1 - y)*s12
	s122   = (x2 - x)*c12 + (y2 - y)*s12
c
c       distance of Q to P1P2, check whether Q is on the left 
c
	r12    = (x1 - x)*s12 - (y1 - y)*c12
	r122   = r12 * r12
c
	if(r12.gt.0.)iphi = iphi+1

c
c       log term
c
	r1     = dsqrt ( (x-x1)**2 + (y-y1)**2 + zsq )
	r2     = dsqrt ( (x-x2)**2 + (y-y2)**2 + zsq )
	r1pr2  = r1 + r2

	if(r12.eq.0.and.az.eq.0) then

c	par passage  la limite. Modif du 21/04/99

	Q12 = 0.d0 ! n'importe quoi de fini

      else

	Q12    = dlog ( (r1pr2 + d12)/(r1pr2 - d12) )

	endif
c
c       atan term : new version, no discontinuity
c       except problems at elements corners
c
	if(r12.eq.0d0) then

c	par passage  la limite. Modif du 21/04/99

	aJ12 = 0.d0

	else

	z2 = r12 * s122 * ( az - r2 )/(r122 * r2 + s122*s122 * az)
	z1 = r12 * s121 * ( az - r1 )/(r122 * r1 + s121*S121 * az)
	aJ12  = datan2 ( z2-z1 , 1.d0 + z1*z2 )

	endif
c
c       Potentiel induced by sources : G term
c
	phi  = phi + r12 * q12 + az * aJ12 
c
c       potential induced by doublets : H term 
c
	dphi = dphi - sgnz * aJ12 
c       
2       continue
c
c       The Green's function is -1/(4 Pi r) !!!
c
	Phi  = Phi  * unsm4Pi
	Dphi = Dphi * unsm4Pi
c
c       The influence of a side on itself is zero       
c
	if(XP.eq.0.d0.and.YP.eq.0.d0.and.ZP.eq.0.d0)then 
c       write(*,'(/'' j :'',i3,'' Dphi = 0'')')j
	DPhi = 0.
c       pause
	endif

c       write(*,'('' i,j  :'',2i4)')i,j
c       write(*,'('' Phi  :'',f10.6,''  Dphi/dz :'',f10.6)')phi,dphi
c       pause

	end
$page
	SUBROUTINE INPUT3D
C

$include:'L3D02.inc'

c
      CHARACTER*80 TITLE
c
      common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax) 
      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              XP(3,4,Nmax), XM(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	COMMON/GEOXTR/ CX(3,LMaX),SOL(LMaX),L


      Pi = 4.d0*datan(1.d0)
      
C
C       NFa = NUMBER OF ELEMENTS 
C       L   = NUMBER OF INTERNAL POINTS WHERE THE FUNCTION IS CALCULATED.
C
C
        WRITE(6,100)
100     FORMAT(' ',79('*'))
C
C       READ JOB TITLE
C
        READ(5,'(A)') TITLE
        WRITE(6,'(A)') TITLE
C
C       READ NUMBER OF ELEMENTS, SYMMETRY INDICATORS AND INTERNAL POINTS
C
        READ(5,*) NFA,MSX,MSY,MSZ,L
        WRITE(6,300) NFA,L
300     FORMAT(//' DATA'//2X,'NUMBER OF BOUNDARY ELEMENTS =',I4/,2X,
     *  'NUMBER OF INTERNAL POINTS WHERE THE FUNCTION IS CALCULATED =',
     *  I4/)

	IF(NFA.GT.NMAX)THEN
	WRITE(*,'('' TOO MANY ELEMENTS :'',I4,''/'',I4,'' (maximum)'')')
     &      NFA, NMAX
      STOP '*** FATAL ERROR ***'  
      ENDIF

	IF(L.GT.LMAX)THEN
	WRITE(*,'('' TOO INTERNAL POINTS :'',I4,''/'',I4,'' (maximum)'')')
     &      L, LMAX
      STOP '*** FATAL ERROR ***'  
      ENDIF
c
c     Traitement des symtries
c
      Nsx = 1
      IF (MSX.eq.1) then
      Write(6,'(''  X-EVEN SYMMETRY'')')
      Nsx = -1
      KSX = 1
      ELSEIF (MSX.eq.-1) then
      Write(6,'(''  X-ODD SYMMETRY'')')
      Nsx = -1
      KSX = -1
      endif

      Nsy = 1
      IF (MSY.eq.1) then
      Write(6,'(''  Y-EVEN SYMMETRY'')')
      Nsy = -1
      KSY = 1
      ELSEIF (MSY.eq.-1) then
      Write(6,'(''  Y-ODD SYMMETRY'')')
      Nsy = -1
      KSY = -1
      endif

      Nsz = 1
      IF (MSZ.eq.1) then
      Write(6,'(''  Z-EVEN SYMMETRY'')')
      Nsz = -1
      KSZ = 1
      ELSEIF (MSZ.eq.-1) then
      Write(6,'(''  Z-ODD SYMMETRY'')')
      Nsz = -1
      KSZ = -1
      endif
C
C
C     Read Coordimates of the nodes
C
C
40      WRITE(6,500)
500     FORMAT(//2X,'COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY',
     *  ' ELEMENTS',//1X,'POINT',7X,'X',15X,'Y')
     
        DO 10 i=1,nfa
     
	  READ(5,*) NCOTE(i),((XP(k,m,i),k=1,3),m=1,Ncote(i))
        WRITE(6,700) I,((XP(k,m,i),k=1,3),m=1,Ncote(i))
700     FORMAT(1X,I4,4(2X,1p3E14.5))
10      continue
C
C       READ BOUNDARY CONDITIONS IN F(I) VERTOR, IF KODE(I)=0 THE FI(I)
C       VALUE IS A KNOWN POTENTIAL;IF KODE(I)=-N THE FI(I) VALUE IS A
C       KNOWN POTENTIAL DERIVATIVE (FLUX).
C
        WRITE(6,800)
800     FORMAT(//2X,'BOUNDARY CONDITIONS'//2X,'NODE',7X,'CODE',8X,
     *  'PRESCRIBED VALUE')
        DO 20 I=1,Nfa
        READ(5,*) KODE(I),VS(I)
20      WRITE(6,950)I,KODE(I),VS(I)
950     FORMAT(1X,I4,9X,I3,8X,1pE14.5)
C
C       READ COORDINATES OF INTERNAL POINTS
C
       IF(L.EQ.0) GOTO 50
	 If (L.gt.Lmax) Then
	 write(*,'('' Too many internal points'')')
	 l = lmax
	 endif
        READ(5,*) ((CX(k,I),k=1,3),I=1,L)
50      CONTINUE
	  END
$page
	subroutine GEOM
c
c	Calcul des centres des facettes
c 	et de leur surface
c

$include	: 'L3D02.inc'
	parameter (NMAX1 = NMAX+1)

c
      common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax) 
      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              XP(3,4,Nmax), XM(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	COMMON/GEOXTR/ CX(3,LMaX),SOL(LMaX),L


      Pi = 4.d0*datan(1.d0)

	do 6 ifa=1,nfa
	nc = ncote(ifa)

	do 4 icor=1,3
	XM(icor,ifa) = 0.d0
c
c	Centres
c	
	do 5 ic=1,nc
5	XM(icor,ifa) = XM(icor,ifa) + XP(icor,ic,ifa) 
	XM(icor,ifa) = XM(icor,ifa) / float(nc)
4	continue
c
c	Surface
c

	SURF(ifa) = 0.d0

	do 1 ic = 1,nc
	if(ic.eq.nc)then
	i1 = nc
	i2 = 1
	else
	i1 = ic
	i2 = ic + 1
	endif

	xP1 = XP(1,i1,ifa)-XM(1,ifa) 
	yP1 = XP(2,i1,ifa)-XM(2,ifa) 
	zP1 = XP(3,i1,ifa)-XM(3,ifa) 

	xP2 = XP(1,i2,ifa)-XM(1,ifa) 
	yP2 = XP(2,i2,ifa)-XM(2,ifa) 
	zP2 = XP(3,i2,ifa)-XM(3,ifa) 

	sX = yP1 * zP2 -  zP1 * yP2
	sY = zP1 * xP2 -  xP1 * zP2
	sZ = xP1 * yP2 -  yP1 * xP2

	surf(ifa) = surf(ifa) + .5d0 * dsqrt ( sX*sX + sY*sY + sZ*sZ )

1	continue

6	continue
	end

	SUBROUTINE INTEMPC
C
C
C
C	THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C


$include	: 'L3D02.inc'

c	
      real*4 time
	common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax) 
      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              XP(3,4,Nmax), XM(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	COMMON/GEOXTR/ CX(3,LMaX),SOL(LMaX),L
	COMMON/GEOXRT2/SOLX(Lmax),SOLY(Lmax),SOLZ(Lmax)	
	DEL = 1.0d-4
C
C
C
	IF(L.EQ.0) RETURN
	call startsw
	DO 40 K=1,L
	if( mod(K,10).eq.0) then
	write(*,'('' Internal points #'',i4,''/'',i4,\)')K,L
	call rclsw(time)
	write(*,'('', time :'',f8.3)')time
	endif

	CALL POTENT(CX(1,K),CX(2,K),CX(3,K),SOL(K))
	CALL POTENT(CX(1,K)+DEL,CX(2,K),CX(3,K),SOLX(K))
	CALL POTENT(CX(1,K),CX(2,K)+DEL,CX(3,K),SOLY(K))
	CALL POTENT(CX(1,K),CX(2,K),CX(3,K)+DEL,SOLZ(K))
	SOLX(K)=(SOLX(K)-SOL(K))/DEL
	SOLY(K)=(SOLY(K)-SOL(K))/DEL
40	SOLZ(K)=(SOLZ(K)-SOL(K))/DEL
	END
$page
C----------------------------------------------------------------------
	SUBROUTINE POTENT(X0,Y0,Z0,F)
C
C
C	THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT INTERNAL POINTS
C

$include	: 'L3D02.inc'

c
      common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax) 
      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              XP(3,4,Nmax), XM(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
C
C	COMPUTE THE VALUES OF POTENTIAL AT INTERNAL POINTS
C
C
C
C     EXAMINES SYMMETRIES
C
	F = 0.d0

c
c       Boucle sur les elements
c
      do j = 1,nfa
c
      G = 0.d0
      H = 0.d0
c
c
c       Generation des 8 points symetriques
c
c
	
      do 20 ix = Nsx,1,2
      Kx = 1
      If(ix.eq.-1) Kx = Ksx
      
      do 20 iy = Nsy,1,2
      Ky = 1
      If(iy.eq.-1) Ky = Ksy
      
      do 20 iz = Nsz,1,2
      Kz = 1
      If(iz.eq.-1) Kz = Ksz
c
c
c

      call lnflux( ix*X0, iy*Y0, iz*Z0 , j, G1, H1)


      G = G + Kx*Ky*Kz * G1
      H = H + Kx*Ky*Kz * H1

20    continue

      
	F = F + H * VS(J) - G * DVS(J)
      
      ENDDO 
C
	END
$page
	subroutine  current
c
c       Calcul des flux sur les portions a Potentiel impose Kode=0
c
c
c     

$include	: 'L3D02.inc'

c
	dimension cur(Nmax)
      common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax) 
      common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &              XP(3,4,Nmax), XM(3,Nmax),
     &              NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	COMMON/GEOXTR/ CX(3,LMaX),SOL(LMaX),L
      Pi = 4.d0*datan(1.d0)

      do 101 i=1,NMaX
101   CUR(i) = 0.d0
c
      JMAX = 0
c
      DO 100 i=1,Nfa

      if(kode(i).lt.0)then    
      j = -Kode(i)
      CUR(j) = CUR(j) + Surf(i)*dvs(i)
      jmax = max0(jmax,j)
      endif
      
100   continue
      if(jmax.ne.0) then
      WRITE(6,'(/'' CURRENTS''/)')
      WRITE(*,'(/'' CURRENTS''/)')
      do 200 j=1, jmax
      WRITE(6,'('' FLUX'',I3,'' :'',1Pe12.5)')j,CUR(j)
      WRITE(*,'('' FLUX'',I3,'' :'',1Pe12.5)')j,CUR(j)
200   continue
      WRITE(6,500)
500   FORMAT(' ',79('*'))
      endif
	end


	SUBROUTINE OUTPMPC
C
C	PROGRAM 27
C
C	THIS SUBROUTINE PRINTS THE VALUES OF THE POTENTIAL AND ITS NORMAL
C	DERIVATIVE AT BOUNDARY NODES. IT ALSO PRINTS THE VALUES OF THE
C	POTENTIAL AT INTERNAL POINTS
C

$include	: 'L3D02.inc'

c
	common/EQS/ SYS1(Nmax,Nmax),DVS(Nmax),Vs(Nmax) 
	common/shape1/nfa, Nsx, Nsy, Nsz, Ksx, Ksy, Ksz,
     &             XP(3,4,Nmax), XM(3,Nmax),
     &             NCOTE(NMAX), KODE(NMAX), SURF(NMAX)
	COMMON/GEOXTR/ CX(3,LMaX),SOL(LMaX),L
	COMMON/GEOXRT2/SOLX(Lmax),SOLY(Lmax),SOLZ(Lmax)	
C
	WRITE(6,100)
100	FORMAT(' ',79('*')//1X,'RESULTS'//2X,'BOUNDARY NODES'//' NODE',
	&8X,'X',15X,'Y',15X,'Z',13X,'POTENTIAL',3X,'POTENTIAL DERIVATIVE',
     &3X,' AREA'/)
	DO 10 I=1,Nfa
10	WRITE(6,200) I,XM(1,I),XM(2,I),XM(3,I),VS(I),DVS(I),SURF(I)
200	FORMAT(I5,6(2X,1Pe14.5))
C
	IF(L.EQ.0) GOTO 30
	WRITE(6,300)
300	FORMAT(//,2X,'INTERNAL POINTS',//8X,'X',15X,'Y',15X,'Z',13X,
     *'POTENTIAL',8X,'GRADV-X',9X,'GRADV-Y',9X,'GRADV-Z'/)
	DO 20 K=1,L
20	WRITE(6,400)CX(1,K),CX(2,K),CX(3,K),SOL(K),SOLX(K),SOLY(K),SOLZ(K)
400	FORMAT(7(2X,1Pe14.5))
30	WRITE(6,500)
500	FORMAT(' ',79('*'))
	RETURN
	END
$page

C----------------------------------------------------------------------
      SUBROUTINE GETFNAMES(FILEIN, FILEOUT)
      
	CHARACTER*(*) FILEIN,FILEOUT  

      na = nargs()

      if(na.ge.2) then
      call getarg(1,FILEIN,ncar)
	WRITE(*,'('' NAME OF INPUT FILE : '',a)')FILEIN(1:ncar)
      else
	WRITE(*,'('' NAME OF INPUT FILE : ''\)')
	READ(*,'(A)')FILEIN
      IF(FILEIN.eq.' ') FILEIN = 'L3D02.IN'            
	endif


      if(na.ge.3) then
      call getarg(2,FILEOUT,ncar)
	WRITE(*,'('' NAME OF OUTPUT FILE : '',a)')FILEOUT(1:ncar)
      else
	WRITE(*,'('' NAME OF OUTPUT FILE : ''\)')
	READ(*,'(A)')FILEOUT
      IF(FILEOUT.eq.' ') FILEOUT = 'L3D02.OUT'            
	endif

	WRITE(*,'(\)')

      END      
C----------------------------------------------------------------------
      SUBROUTINE XXXGETFNAMES(FILEIN, FILEOUT)
      
	CHARACTER*(*) FILEIN,FILEOUT  

      WRITE(*,'('' NAME OF INPUT FILE : ''\)')
	READ(*,'(A)')FILEIN
      IF(FILEIN.eq.' ') FILEIN = 'L3D02.in'            

      WRITE(*,'('' NAME OF OUTPUT FILE : ''\)')
      READ(*,'(A)')FILEOUT
      IF(FILEOUT.eq.' ') FILEOUT = 'L3D02.out'
      
      END      



	subroutine DGSEIDEL(x,y,w,nx,ny,Nmax,eps,ier)
c
c
c	        This is a routine designed to solve a set of n linear eqations
c	        by the JACOBI ITERATION Technique
c
c	        parameters :
c
c	x...............nmax*nx real*8 matrix containing the coefficients of 
c	                the equations
c	y...............nmax*ny real*8 matrix containing the right hand sides.
c	                Returns the solution
c	w...............nmax*ny real*8 matrix initial guess of the solution.
c	                Returns the RMS of errors on y as W(1)
c	nx..............integer*2 number of unkowns and number of equations
c	ny..............integer*2 number of R.H.S
c	Nmax............Actual number of row of X and Y
c	eps.............Threshold for the pivot
c	ier.............integer*2 return code
c			 0: resolution completed succesfully
c			-i: pivot not found in step i of elimination
c
c		27 Juin 2002     
c
      implicit real*8 (a-h,o-z)
	dimension x(nmax,nx),y(nmax,ny),w(nmax,ny)
c
c
c
	Niter = 0
	err = 2.d0*eps

	do while(err.gt.eps)

	err = 0.d0
	do i=1,Nx

	do k=1,Ny
	sum = 0.d0
	do j=1,Nx
	if(i.ne.j)sum = sum+x(i,j)*w(j,k)
	enddo
	wnew = (y(i,k)-sum)/x(i,i)
	derr = w(i,k)-wnew
	w(i,k)= wnew
	err = err + derr**2
	enddo

	enddo

	err = dsqrt(err/dble(Nx*Ny))

	niter = niter + 1

	write(*,'('' Niter :'',i3,''  RMS error :'',1Pe10.3)')niter, err

	if(niter.gt.nx)then
c	write(*,'('' Too many iterations in GSEIDEL :'',i4,''/'',i4)')
c	& niter,Nx
	ier=-niter
	endif

	enddo

	do i=1,nx
	do k=1,ny
	y(i,k)=w(i,k)
	enddo
	enddo
	w(1,1)=err
	
c
c		return to calling routine
c
	return
	end
