	subroutine STRDJ(arg,nc,IVAL,*)
c
c
c	Lecture d'un entier POSITIF dans une chaine de charactere
c
c	arg..........Chaine de charactere
c	nc...........Nombre de characteres utiles de la chaine
c	IVAL.........Valeur numerique
c	*............Adresse de retour en cas d'erreur de lecture
c
c	Cette fonction est equivalente au VIEUX fortran et simule
c
c	read(arg,*,end=xxx)ival
c
c
	character arg(nc),car
c
	IVAL = 0
	INIT = 0
	I = 1	
c
c	Boucle sur les characteres
c	

100	continue
	car = arg(I)
	icar = ichar(car)
c
c	Traitement des Blancs
c		
c
c	Leading blanks skipped, Trailing blanks : end process
c
	if(car.ne.' ') goto 10
	if(init.eq.0)  goto 90
	return
10	continue
c
c	Check if Figure
c
	if(.NOT.(icar.ge.48.and.icar.le.57) ) goto 30
	INIT = 1
	IVAL = IVAL * 10 + icar - 48 
	goto 90
c
c	Error return
c
30	continue
	IVAL = 0
	return 1
c
c	Increment Pointer
c	and go tot next character
c
90	I = I + 1
	if ( I.le.nc ) goto 100 
c
c	Loop finished
c
	end
$Page
	subroutine STRDI(arg,nc,IVAL,*)
c
c
c	Lecture d'un entier signe dans une chaine de charactere
c
c	arg..........Chaine de charactere
c	nc...........Nombre de characteres utiles de la chaine
c	IVAL.........Valeur numerique
c	*............Adresse de retour en cas d'erreur de lecture
c
c	Cette fonction est equivalente au VIEUX fortran et simule
c
c	read(arg,*,end=xxx)ival
c
c
	character arg(nc),car
c
	IVAL = 0
	INIT = 0
	I = 1	
	IS = 1
c
c	Boucle sur les characteres
c	

100	continue
	car = arg(I)
	icar = ichar(car)
c
c	Traitement des Blancs
c		
c
c	Leading blanks skipped, Trailing blanks : end process
c
	if(car.ne.' ') goto 10
	if(init.eq.0)  goto 90
	IVAL = IVAL * IS
	return
10	continue
c
c	Check sign. First occurence no figures  : OK
c	occurs and init non zero : error
c
	if(.NOT. (car.eq.'+'.or.car.eq.'-') ) goto 20
	if(init.ne.0)goto 30
	INIT = 1
	if(car.eq.'-') IS = -1
	goto 90	
20	continue
c
c	Check if Figure
c
	if(.NOT.(icar.ge.48.and.icar.le.57) ) goto 30
	INIT = 1
	IVAL = IVAL * 10 + icar - 48 
	goto 90
c
c	Error return
c
30	continue
	IVAL = 0
	return 1
c
c	Increment Pointer
c	and go tot next character
c
90	I = I + 1
	if ( I.le.nc ) goto 100 
c
c	Loop finished
c
	IVAL = IVAL * IS
	end
$Page
	subroutine STRDF(arg,nc,FVAL,*)
c
c
c	Lecture d'un reel signe flottant (F)dans une chaine de charactere
c
c	arg..........Chaine de charactere
c	nc...........Nombre de characteres utiles de la chaine
c	FVAL.........Valeur numerique
c	*............Adresse de retour en cas d'erreur de lecture
c
c	Cette fonction est equivalente au VIEUX fortran et simule
c
c	read(arg,*,end=xxx)FVAL
c
c
	character arg(nc),car
c
	IVAL = 0
	INIT = 0
	I = 1	
	IS = 1
	IDECAL = 0
c
c	Boucle sur les characteres
c	

100	continue
	car = arg(I)
	icar = ichar(car)
c
c	Traitement des Blancs
c		
c
c	Leading blanks skipped, Trailing blanks : end process
c
	if(car.ne.' ') goto 10
	if(init.eq.0)  goto 90
	goto 110
10	continue
c
c	Check sign. First occurence no figures  : OK
c	occurs and init non zero : error
c
	if(.NOT. (car.eq.'+'.or.car.eq.'-') ) goto 20
	if(init.ne.0)goto 30
	INIT = 1
	if(car.eq.'-') IS = -1
	goto 90	
20	continue
c
c	Check if period, if already occurs : error
c
	if(car.ne.'.')goto 25
	if(idecal.ne.0)goto 30	
	idecal = 1
	goto 90
25	continue
c
c	Check if Figure
c
	if(.NOT.(icar.ge.48.and.icar.le.57) ) goto 30
	INIT = 1
	IVAL = IVAL * 10 + icar - 48 
c
c	increment shift if period occurs
c
	if(idecal.ne.0) IDECAL = IDECAL * 10
	goto 90
c
c	Error return
c
30	continue
	FVAL = 0
	return 1
c
c	Increment Pointer
c	and go tot next character
c
90	I = I + 1
	if ( I.le.nc ) goto 100 
c
c	Loop finished
c	and normal return
c
110	continue
	FVAL = float(IVAL) 
	if(  is   . lt . 0 ) FVAL = -FVAL
	if(idecal . gt . 1 ) FVAL =  FVAL / float(IDECAL)
	end

$Page
	subroutine STRDE(arg,nc,EVAL,*)
c
c
c	Lecture d'un reel signe flottant (E)dans une chaine de charactere
c
c	arg..........Chaine de charactere
c	nc...........Nombre de characteres utiles de la chaine
c	EVAL.........Valeur numerique
c	*............Adresse de retour en cas d'erreur de lecture
c
c	Cette fonction est equivalente au VIEUX fortran et simule
c
c	read(arg,*,end=xxx)EVAL
c
c
	character arg(nc),car
c
c	Check for Exponent
c
	do 5 iexp=1,nc
	if(arg(iexp).eq.'e'.or.arg(iexp).eq.'E'.or.
     *     arg(iexp).eq.'d'.or.arg(iexp).eq.'D' ) goto 10
5	continue
	iexp = nc + 1
10	continue
c
c	read first part
c
	call STRDF(arg,iexp-1,EVAL,*100)
c
c	Read exponent if necessary if nothing to read, end process
c
	if(iexp .ge. nc) return
	mc = nc - iexp
	call STRDI(arg(iexp+1),mc,I,*100)
	if ( i.eq.0 ) return
	EVAL = EVAL * ( 10. ) ** I
	return
c
c	Error return
c
100	continue
	EVAL = 0
	return 1
	end