	implicit real*8 (a-h,o-z)
	parameter (NMAX=5000)
	parameter (NPMX=101)
      common/mesh/ nfa, VS(NMAX), KODE(NMAX),XP(3,4,Nmax),NCOTE(NMAX)
      common/prof/ Nprof, Nth, Rprof(npmx),Zprof(npmx)
c
        open(2,file='l3D02.in')
	Pi = 4.d0*Datan(1.d0)
c
c
c     Fabrication de la mridienne
c
c
        NPsi = 16*1
	  A = 1.d0
c
        nprof = NPsi + 1
        nth   = 16*1  
c
c     Mridienne de bas en haut
c        
        j = 0
        Do 3 i= 0, Npsi
        Psi = Pi - Pi * Dble(i)/Dble(Npsi)
        X = A*dcos(Psi)
        Y = A*dsin(Psi)
        j = j+1
        Rprof(j) = Y
        Zprof(j) = X
3       continue        


      Nprof = j
      nfa = 0
c
      write(*,'(i5,2f10.6)')(i,Rprof(i),Zprof(i),i=1,Nprof)
c
c     Maillage de rvolution
c      
      call Parmer(4)
c
c     Conditions aux limites
c
      call BCOND      
c                 
c     Impression du maillage
c
      write(2,'('' 3DCYL01, Nfa='',i4)')nfa
      write(2,'(5i4)')nfa,0,0,0,0
c
      do 1 i=1,nfa
      write(2,'(i5,4(2x,3f20.12))')NCOTE(i),
     &               ((XP(k,l,i),k=1,3),l=1,Ncote(i))
1     continue
c
      do 2 i=1,nfa
      write(2,'(i5,f20.12)')Kode(i), vs(i)
2     continue      

      end
$page
      subroutine BCOND
c
c
c	Conditions aux limites
c
c
	implicit real*8 (a-h,o-z)
	parameter (NMAX=5000)
	parameter (NPMX=101)
c
      common/mesh/ nfa, VS(NMAX), KODE(NMAX),XP(3,4,Nmax),NCOTE(NMAX)
	common/prof/ Nprof, Nth, Rprof(npmx),Zprof(npmx)
	data small/1.d-6/

      Pi = 4.d0*datan(1.d0)
c
c     
c
      do 1 i=1,nfa 
	Zg = 0.d0
	do j=1,ncote(i); Zg=Zg+XP(3,j,i); enddo ; Zg=Zg/dble(Ncote(i))
	Xg = 0.d0
	do j=1,ncote(i); Xg=Xg+XP(1,j,i); enddo ; Xg=Xg/dble(Ncote(i))
	Yg = 0.d0
	do j=1,ncote(i); Yg=Yg+XP(1,j,i); enddo ; Yg=Yg/dble(Ncote(i))

      Kode(i) = 0
      VS(i)   = Xg**2+Yg**2-2.d0*Zg**2
      
1     continue      

      end
$page
	subroutine PARMER(iquart)
c
c
c	Maillage d'une surface de rvolution
c
c
	implicit real*8 (a-h,o-z)
	parameter (NMAX=5000)
	parameter (NPMX=101)
c
      common/mesh/ nfa, VS(NMAX), KODE(NMAX),XP(3,4,Nmax),NCOTE(NMAX)
	common/prof/ Nprof, Nth, Rprof(npmx),Zprof(npmx)
	data small/1.d-6/

      Pi = 4.d0*datan(1.d0)
c
c     Fabrication du maillage  partir de la mridienne
c
	dth = iquart *Pi/2.d0 /dble(nth) 

	ifa = nfa + 1
	th = 0.d0
c
	do 1 ith = 1,nth
c
	do 2 iprof = 1,nprof-1
c	
	if(iprof.eq.1.and.dabs(Rprof(iprof)).lt.small) then
c
c	Facette touchant l'axe au debut du profil : 3 cotes
c 
c	P1 = ( r=0, z=Zprof(1) )
c
	Ncote(ifa) = 3
c	
	XP(1,1,ifa) = 0.d0
	XP(2,1,ifa) = 0.d0
	XP(3,1,ifa) = Zprof(1)
c 
c	P2 = (r = Rprof(2), theta = th+dt, z = Zprof(2) )
c
	XP(1,2,ifa) = Rprof(2) * dcos(th + dth)
	XP(2,2,ifa) = Rprof(2) * dsin(th + dth)
	XP(3,2,ifa) = Zprof(2)                
c 
c	P3 = (r = Rprof(2), theta = th, z = Zprof(2) ) 
c
	XP(1,3,ifa) = Rprof(2) * dcos(th)
	XP(2,3,ifa) = Rprof(2) * dsin(th)
	XP(3,3,ifa) = Zprof(2)
c
c	Facette touchant l'axe a la fin du profil : 3 cotes
c 
c	P1 = ( r=0, z=Zprof(nprof) )
c
	elseif(iprof.eq.(nprof-1).and.dabs(Rprof(nprof)).lt.small) then
	Ncote(ifa) = 3
c	
	XP(1,1,ifa) = 0.d0
	XP(2,1,ifa) = 0.d0
	XP(3,1,ifa) = Zprof(nprof)
c 
c	P2 = (r = Rprof(nprof-1), theta = th, z = Zprof(nprof-1) )
c
	XP(1,2,ifa) = Rprof(nprof-1) * dcos(th)
	XP(2,2,ifa) = Rprof(nprof-1) * dsin(th)
	XP(3,2,ifa) = Zprof(nprof-1)                
c 
c	P3 = (r = Rprof(nprof-1), theta = th+dt, z = Zprof(nprof-1) ) 
c
	XP(1,3,ifa) = Rprof(nprof-1) * dcos(th+dth)
	XP(2,3,ifa) = Rprof(nprof-1) * dsin(th+dth)
	XP(3,3,ifa) = Zprof(nprof-1)                
c
c
c	Zone Mediane : 4 cotes
c
c 
c	P1 = (r = Rprof(iprof), theta = th, z = Zprof(iprof) )
c
	else
	Ncote(ifa) = 4
c
	XP(1,1,ifa) = Rprof(iprof) * dcos(th)      
	XP(2,1,ifa) = Rprof(iprof) * dsin(th)      
	XP(3,1,ifa) = Zprof(iprof)                
c 
c	P2 = (r = Rprof(iprof), theta = th+dt, z = Zprof(iprof) )
c
	XP(1,2,ifa) = Rprof(iprof) * dcos(th+dth)      
	XP(2,2,ifa) = Rprof(iprof) * dsin(th+dth)      
	XP(3,2,ifa) = Zprof(iprof)                
c 
c	P3 = (r = Rprof(iprof+1), theta = th+dt, z = Zprof(iprof+1) )
c
	XP(1,3,ifa) = Rprof(iprof+1) * dcos(th+dth)   
	XP(2,3,ifa) = Rprof(iprof+1) * dsin(th+dth)   
	XP(3,3,ifa) = Zprof(iprof+1)                
	
c 
c	P4 = (r = Rprof(iprof+1), theta = th, z = Zprof(iprof+1) )
c
	XP(1,4,ifa) = Rprof(iprof+1) * dcos(th)   
	XP(2,4,ifa) = Rprof(iprof+1) * dsin(th)   
	XP(3,4,ifa) = Zprof(iprof+1)                
c
	endif
c
c	Next element
c
	ifa = ifa+1

2	continue
c
c	Next strip
c
	th = th + dth
1	continue	
c
c	update the value of nfa
c
      nfa = nfa + nth * (nprof-1)
c
c     
      end
