	implicit real*8 (a-h,o-z)
	parameter (NMAX=5000)
	parameter (NPMX=500)
      common/mesh/ nfa, VS(NMAX), KODE(NMAX),XP(3,4,Nmax),NCOTE(NMAX)
      common/prof/ Nprof, Nth, Rprof(npmx),Zprof(npmx)
	pi = 4.d0*datan(1.d0)
c
        open(2,file='l3D02.in')
c
c
c     Fabrication de la mridienne
c
c
	ntimes = 8
        NP  = 4*ntimes
        NC  = 4*ntimes
        H = 1.d0
        D = 2.d0
c
        nprof = NP + NC + 1
        nth   = 4*ntimes
c
c     Mridienne de bas en haut
c        
        j = 0
c
        Do 4 i=0, Nc-1
        x  = H*dble(i)/dble(Nc)
        Y  = D/2.d0 
        j = j+1
        Rprof(j) = Y
        Zprof(j) = x
4       continue        
c        
        Do 5 i=0, Np
        x = H
        Y = D/2.d0-D/2.d0*dble(i)/dble(nP) 
        j = j+1
        Rprof(j) = Y
        Zprof(j) = X
5       continue
c
      Nprof = j
      nfa = 0
c
c      write(2,'(i5,2f10.6)')(i,Rprof(i),Zprof(i),i=1,Nprof)
c
c     Maillage du cylindre
c      
      call Parmer(1)
c
c     Conditions aux limites
c
      call BCOND(D,H)      
c                 
c     Impression du maillage
c
      write(2,'('' Test3D04, Nfa='',i4)')nfa
      write(2,'(5i4)')nfa,-1,1,-1,1
      do 1 i=1,nfa
      write(2,'(i5,4(2x,3f20.12))')NCOTE(i),
     &               ((XP(k,l,i),k=1,3),l=1,Ncote(i))
1     continue
c
      do 2 i=1,nfa
      write(2,'(i5,f20.12)')Kode(i), vs(i)
2     continue      
c
c	Points intrieurs
c
	zz = .5d0*dcos(pi/4.d0)
	xx = .5d0*dcos(pi/4.d0)**2
      write(2,'(3f20.12)')xx,xx,zz
	end
$page
      subroutine BCOND(D,H)
c
c
c	Conditions aux limites
c
c
	implicit real*8 (a-h,o-z)
	parameter (NMAX=5000)
	parameter (NPMX=500)
c
      common/mesh/ nfa, VS(NMAX), KODE(NMAX),XP(3,4,Nmax),NCOTE(NMAX)
	common/prof/ Nprof, Nth, Rprof(npmx),Zprof(npmx)
	data small/1.d-6/

      Pi = 4.d0*datan(1.d0)
c
c     
c
      do 1 i=1,nfa 

	Zg = 0.d0
	do j=1,ncote(i); Zg=Zg+XP(3,j,i); enddo ; Zg=Zg/dble(Ncote(i))
	Xg = 0.d0
	do j=1,ncote(i); Xg=Xg+XP(1,j,i); enddo ; Xg=Xg/dble(Ncote(i))
	Yg = 0.d0
	do j=1,ncote(i); Yg=Yg+XP(1,j,i); enddo ; Yg=Yg/dble(Ncote(i))

      If(Zg.lt.H-small)then
c	paroi cylindrique
      Kode(i) = 0
      VS(i)   = 3*Xg*Zg
      else
c	Paroi plane
c      Kode(i) = 0
c      VS(i)   = 3*Xg*Zg
      Kode(i) = 1
      VS(i)   = 3*Xg
      endif
      
1     continue      

      end
$page
	subroutine PARMER(iquart)
c
c
c	Maillage d'une surface de rvolution
c
c
	implicit real*8 (a-h,o-z)
	parameter (NMAX=5000)
	parameter (NPMX=500)
c
      common/mesh/ nfa, VS(NMAX), KODE(NMAX),XP(3,4,Nmax),NCOTE(NMAX)
	common/prof/ Nprof, Nth, Rprof(npmx),Zprof(npmx)
	data small/1.d-6/

      Pi = 4.d0*datan(1.d0)
c
c     Fabrication du maillage  partir de la mridienne
c
	dth = iquart *Pi/2.d0 /dble(nth) 

	ifa = nfa + 1
	th = 0.d0
c
	do 1 ith = 1,nth
c
	do 2 iprof = 1,nprof-1
c	
	if(iprof.eq.1.and.dabs(Rprof(iprof)).lt.small) then
c
c	Facette touchant l'axe au debut du profil : 3 cotes
c 
c	P1 = ( r=0, z=Zprof(1) )
c
	Ncote(ifa) = 3
c	
	XP(1,1,ifa) = 0.d0
	XP(2,1,ifa) = 0.d0
	XP(3,1,ifa) = Zprof(1)
c 
c	P2 = (r = Rprof(2), theta = th+dt, z = Zprof(2) )
c
	XP(1,2,ifa) = Rprof(2) * dcos(th + dth)
	XP(2,2,ifa) = Rprof(2) * dsin(th + dth)
	XP(3,2,ifa) = Zprof(2)                
c 
c	P3 = (r = Rprof(2), theta = th, z = Zprof(2) ) 
c
	XP(1,3,ifa) = Rprof(2) * dcos(th)
	XP(2,3,ifa) = Rprof(2) * dsin(th)
	XP(3,3,ifa) = Zprof(2)
c
c	Facette touchant l'axe a la fin du profil : 3 cotes
c 
c	P1 = ( r=0, z=Zprof(nprof) )
c
	elseif(iprof.eq.(nprof-1).and.dabs(Rprof(nprof)).lt.small) then
	Ncote(ifa) = 3
c	
	XP(1,1,ifa) = 0.d0
	XP(2,1,ifa) = 0.d0
	XP(3,1,ifa) = Zprof(nprof)
c 
c	P2 = (r = Rprof(nprof-1), theta = th, z = Zprof(nprof-1) )
c
	XP(1,2,ifa) = Rprof(nprof-1) * dcos(th)
	XP(2,2,ifa) = Rprof(nprof-1) * dsin(th)
	XP(3,2,ifa) = Zprof(nprof-1)                
c 
c	P3 = (r = Rprof(nprof-1), theta = th+dt, z = Zprof(nprof-1) ) 
c
	XP(1,3,ifa) = Rprof(nprof-1) * dcos(th+dth)
	XP(2,3,ifa) = Rprof(nprof-1) * dsin(th+dth)
	XP(3,3,ifa) = Zprof(nprof-1)                
c
c
c	Zone Mediane : 4 cotes
c
c 
c	P1 = (r = Rprof(iprof), theta = th, z = Zprof(iprof) )
c
	else
	Ncote(ifa) = 4
c
	XP(1,1,ifa) = Rprof(iprof) * dcos(th)      
	XP(2,1,ifa) = Rprof(iprof) * dsin(th)      
	XP(3,1,ifa) = Zprof(iprof)                
c 
c	P2 = (r = Rprof(iprof), theta = th+dt, z = Zprof(iprof) )
c
	XP(1,2,ifa) = Rprof(iprof) * dcos(th+dth)      
	XP(2,2,ifa) = Rprof(iprof) * dsin(th+dth)      
	XP(3,2,ifa) = Zprof(iprof)                
c 
c	P3 = (r = Rprof(iprof+1), theta = th+dt, z = Zprof(iprof+1) )
c
	XP(1,3,ifa) = Rprof(iprof+1) * dcos(th+dth)   
	XP(2,3,ifa) = Rprof(iprof+1) * dsin(th+dth)   
	XP(3,3,ifa) = Zprof(iprof+1)                
	
c 
c	P4 = (r = Rprof(iprof+1), theta = th, z = Zprof(iprof+1) )
c
	XP(1,4,ifa) = Rprof(iprof+1) * dcos(th)   
	XP(2,4,ifa) = Rprof(iprof+1) * dsin(th)   
	XP(3,4,ifa) = Zprof(iprof+1)                
c
	endif
c
c	Next element
c
	ifa = ifa+1

2	continue
c
c	Next strip
c
	th = th + dth
1	continue	
c
c	update the value of nfa
c
      nfa = nfa + nth * (nprof-1)

      end
$page
	real*8 function BESI0(x)
c
c       Bessel function of order 0 multiplied by exp(-|x|)
c
	implicit real*8 (a-h,o-z)
	dimension c(7),d(9)
	data d/ .39894 228,     .01328 592,     .00225 319,
     &          -.00157 565,    .00916 281,     -.02057 706,
     &          .02635 537,     -.01647 633,    .00392 377 /
	data c/ 1.      ,       3.5156229,      3.0899424,
     &          1.2067492,      .2659732,       .0360768,       
     &          .0045813 /
c
	t = x / 3.75
	ax = abs(x)
c
	if(abs(t).le.1.) then
c
	t = t*t
	BESI0 = (((((C(7)*t+C(6))*t+C(5))*t+C(4))*t+C(3))*t+C(2))*t+C(1)
	eax = exp(ax)
	BESI0 = BESI0 / eax
	else
	t = 1./abs(t)   
	BESI0 = (((((((D(9)*t+D(8))*t+D(7))*t+D(6))*t+D(5))*t+D(4))*t
     &          +D(3))*t+D(2))*t+D(1)
	BESI0 = BESI0 / sqrt(ax) 
	endif
	end     
$page
	real*8 function BESI1(x)
c
c       Bessel function of order 1 multiplied by exp(-|x|)
c
	implicit real*8 (a-h,o-z)
	dimension c(7),d(9)
	data d/ .39894 228,     -.03988 024,    -.00362 018,
     &          .00163 801,     -.01031 555,    .02282 967,
     &          -.02895 312,    .01787 654,     -.00420 059/
	data c/ .5,             .87890 594,     .51498 869,
     &          .15084 934,     .02658 733,     .00301 532,
     &          .00032 411/
c
	t = x/3.75
	ax = abs(x)
	if(abs(t).le.1.) then
c
	t = t*t
	BESI1 = (((((C(7)*t+C(6))*t+C(5))*t+C(4))*t+C(3))*t+C(2))*t+C(1)
	BESI1 = X * BESI1 * exp(-ax)
	else
	t = 1./abs(t)   
	BESI1 = (((((((D(9)*t+D(8))*t+D(7))*t+D(6))*t+D(5))*t+D(4))*t
     &          +D(3))*t+D(2))*t+D(1)
	BESI1 = BESI1 / sqrt(ax)
	endif
	end

